#include "lcd.h"
#include "usart.h"
#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>
#include "dht.h"
#include<string.h>

int main()
{
    char temp_msg[30];
    char fire_msg[30];
    char fire_msg_send[30];
    int8_t temperature = 0;
	int8_t hummidity = 0;
    char ref_temp[5];

    //configuratii initiale
    DDRB |= (1 << PB3);
    LCD_init();
    USART0_init();

    memset(fire_msg, '\0', sizeof(fire_msg));
    LCD_printAt(0x00, "Set ref temp");
    USART0_print("Set ref temperature\n");
    USART0_receive_string(ref_temp);
    LCD_writeInstr(LCD_INSTR_clearDisplay);

    while(1)
	{
        //citire temperatura
        _delay_ms(100);
        dht_gettemperaturehumidity(&temperature, &hummidity);
        _delay_ms(100);
        memset(temp_msg, '\0', sizeof(temp_msg));
		sprintf(temp_msg, "Temp: %d C", (int)temperature);

        //verificare atingere prag de incendiu
        if (temperature >= atoi(ref_temp)) {
		    sprintf(fire_msg, "FIRE!");
            LCD_printAt(0x00, temp_msg);
            LCD_printAt(0x40, fire_msg);
            memset(fire_msg_send, '\0', sizeof(fire_msg_send));
            sprintf(fire_msg_send, "Temp: %d C\nFIRE!\n", (int)temperature);           
            USART0_print(fire_msg_send);
            // declansare buzzer
            PORTB |= (1 << PB3);
            _delay_ms(1000);
            PORTB &= ~(1 << PB3);
        } else {
            if (fire_msg != NULL) {
                memset(fire_msg, 0, sizeof(fire_msg));
                LCD_writeInstr(LCD_INSTR_clearDisplay);
            }
            LCD_printAt(0x00, temp_msg);
        }
        
    }
    return 0;
}

